diff --git a/boards/common/particle-mesh/board.c b/boards/common/particle-mesh/board.c
index d25c4b8f1ba0..b151c4fbdd2f 100644
--- a/boards/common/particle-mesh/board.c
+++ b/boards/common/particle-mesh/board.c
@@ -45,6 +45,35 @@ void board_nrfantenna_select(enum board_nrfantenna_selection choice)
 
 void board_init(void)
 {
+#ifdef PARTICLE_MONOFIRMWARE
+    // Set VTOR address to where our vector table is located (as does micropython)
+    // FIXME:
+    // * Use the abstractions (probbably this is the SCB->VTOR = _isr_Vectors
+    //   already present in cortexm_init.c
+    // * Find out whether this is actually required
+    // * If so, consider whether there's any benefit to an unpinned vectro
+    //   table now that we need to set it ourselves anyway. (Note that Particle
+    //   bootloader still appears to look into two magic locations: the
+    //   firmware start to see whether it contains something that looks like a
+    //   stack start address and a reset vector to jump into, and the
+    //   module_info_t at offset 0x200).
+    *((volatile uint32_t*)0xe000ed08) = 0x30000;
+
+    // Force keeping this sections -- the __attribute__((used)) in their macro
+    // expansions should do that, need to investigate.
+    extern uint32_t particle_monofirmware_padding;
+    extern uint32_t particle_monofirmware_module_info;
+    volatile uint32_t x;
+    x = (uint32_t)&particle_monofirmware_padding;
+    x = (uint32_t)&particle_monofirmware_module_info;
+    (void)x;
+
+    // Clear out POWER_CLOCK and GPIOTE interrupts set by the bootloader. (If
+    // something does enable them, it'll do so after the board_init call).
+    NVIC_DisableIRQ(0);
+    NVIC_DisableIRQ(6);
+#endif
+
     /* initialize the boards LEDs */
     gpio_init(LED0_PIN, GPIO_OUT);
     gpio_set(LED0_PIN);
diff --git a/boards/particle-xenon/Makefile.include b/boards/particle-xenon/Makefile.include
index 9a16211c4105..089f6c35042f 100644
--- a/boards/particle-xenon/Makefile.include
+++ b/boards/particle-xenon/Makefile.include
@@ -1 +1,17 @@
+CFLAGS += -DPARTICLE_MONOFIRMWARE
+LINKER_SCRIPT ?= $(RIOTBOARD)/$(BOARD)/ldscripts/in-particle-monofirmware.ld
+FLASHFILE = $(BINFILE)-checksummed
+FLASHER = dfu-util
+FFLAGS = -d 0x2B04:0xD00E -a 0 -s 0x30000:leave -D ${FLASHFILE}
+
+%.bin-checksummed: %.bin %.elf
+	# Verify that the module info is at the right location
+	nm --print-size "$*.elf" |grep "00030200 00000018 T particle_monofirmware_module_info" >/dev/null
+	
+	#python3 -c "import sys; data = sys.stdin.buffer.read(); assert int.from_bytes(data[0x204:4], 'little') == len(data) + 0x30000, 'module_info calculated wrong binary size'" < "$<"
+	#cp "$<" "$@"
+	python3 -c "import sys; data = sys.stdin.buffer.read(); sys.stdout.buffer.write(data[:0x204] + (len(data) + 0x30000).to_bytes(4, 'little') + data[0x208:])" < "$<" > "$@"
+	
+	python3 -c "import sys, zlib; sys.stdout.buffer.write(zlib.crc32(open(sys.argv[-1], 'rb').read()).to_bytes(4, 'big'))" "$@" >> "$@"
+
 include $(RIOTBOARD)/common/particle-mesh/Makefile.include
diff --git a/boards/particle-xenon/bootloader.c b/boards/particle-xenon/bootloader.c
new file mode 100644
index 000000000000..5a6a06f794dd
--- /dev/null
+++ b/boards/particle-xenon/bootloader.c
@@ -0,0 +1,35 @@
+#ifdef PARTICLE_MONOFIRMWARE
+#include <stdint.h>
+#include "vectors_cortexm.h"
+
+extern const void *_isr_vectors;
+extern uint32_t _etext, _srelocate, _erelocate;
+
+// As described in Particle's dynalib/inc/module_info.h (there under LGPL-3
+// terms; detailed license compatibility discussion skipped for not crossing
+// any threshold of originality)
+typedef struct module_info_t {
+    const void* module_start_address;
+    const void* module_end_address;
+    uint8_t reserved;
+    uint8_t flags;
+    uint16_t module_version;
+    uint16_t platform_id;
+    uint8_t  module_function;
+    uint8_t  module_index;
+    uint32_t dependency; // was module_dependency_t; kept in here to ensure it's blank
+    uint32_t dependency2; // was module_dependency_t
+} module_info_t;
+
+// 66 words is the distance between the known ISR table and the fixed-position module_info at 0x200.
+ISR_VECTOR(50) const uint32_t particle_monofirmware_padding[66] = {0, };
+
+ISR_VECTOR(51) const struct module_info_t particle_monofirmware_module_info = {
+    .module_start_address = &_isr_vectors,
+    // .module_end_address = &_etext + (&_erelocate - &_srelocate), // Not computable at compile time, letting the Makefile patch that
+    .module_version = 0x138, // module version that micropython uses
+    .platform_id = 14, // Xenon; see Particle's build/platform-id.mk
+    .module_index = 3, // MOD_FUNC_MONO_FIRMWARE from dynalib/inc/module_info.h
+};
+
+#endif
diff --git a/boards/particle-xenon/ldscripts/in-particle-monofirmware.ld b/boards/particle-xenon/ldscripts/in-particle-monofirmware.ld
new file mode 100644
index 000000000000..133dec8d639a
--- /dev/null
+++ b/boards/particle-xenon/ldscripts/in-particle-monofirmware.ld
@@ -0,0 +1,7 @@
+MEMORY
+{
+    rom (rx)    : ORIGIN =    0x30000, LENGTH = 0xc4000
+    ram (w!rx)  : ORIGIN = 0x20000000, LENGTH = 0x40000
+}
+
+INCLUDE cortexm_base.ld
